% ==============================================
%
% CBP 24-03-18
%
% Right Hand side for WindTurbine solver
%
% ==============================================
  
function xd=rhs_windturbine_1(t,x)

global R rho J windV LUT CpMax tsrOptim

xd = zeros(2,1);

theta = x(1);
omega = x(2);

if(t < 50) windV = 8;
elseif( (t >= 50) && ( t < 100) ) windV = 10;
elseif( (t >= 100) && ( t < 150) ) windV = 12;
elseif( (t >= 150) && ( t < 200) ) windV = 14;
else windV = 16;
endif

tsr = omega * R / windV;

Cp = lookupPowerCoefficient(tsr,3.7,LUT);

torqueW = (1/2) * rho * pi * R**5 * (lookupPowerCoefficient(tsr,0,LUT)/tsr**3) * omega**2;

torqueG = (1/2) * rho * pi * R**5 * (CpMax/tsrOptim**3) * omega**2;

error = torqueW - torqueG;
 
xd(1) = x(2);
xd(2) = error/J;

endfunction

