% =============================================================================
% 
% Solver for WindTurbine with increasing windSpeeds
%
% Needs rhs_windturbine_1, buildPowerCoefficientsLUT, lookupPowerCoefficient,
% applyWind
%
% solve_WindTurbine_1.,
%
% CBP 30-03-18
%
% ==============================================================================

global R rho J windV LUT CpMax tsrOptim

tstart = 0;
tend = input('Input end time');

R = 20;
R = input('Input R ');
rho = 1.2;
J = 644877;
windV = 8;
tsrOptim = 5.29;
CpMax = 0.4528
  
  for i=1:120  
    LUT(i) = 0.1;
  endfor
  
buildPowerCoefficientsLUT(LUT);

xinit = [0,4];

options = odeset('RelTol',1e-6,'AbsTol',1e-6,'InitialStep',tend/1e3,'MaxStep',tend/1e3);

[t,x] = ode45(@rhs_windturbine_1,[tstart,tend],xinit,options);


for i = 1 : length(t)
  ttsr(i) = R*x(i,2)/applyWind(t(i));
  CCp(i) = lookupPowerCoefficient(ttsr(i),3.7,LUT);
endfor

figure(1);
subplot(3,1,1);
plot(t,x(:,2),'r');
title('omega');
subplot(3,1,2);
plot(t,ttsr,'r');
title('tsr');
subplot(3,1,3);
plot(t,CCp,'r');
title('Cp');

figure(2)
plot(t,x(:,2),'r');
title('omega');
xlabel('time');
