% =============================================================================
% 
% Solver for WindTurbine with increasing windSpeeds
%
% Needs rhs_windturbine_1, buildPowerCoefficientsLUT, lookupPowerCoefficient,
% applyWind
%
% CBP 30-03-18
%
% ==============================================================================

global R rho J windV LUT CpMax tsrOptim G C

tstart = 0;
tend = input('Input end time');
G = input('Input Optimal Gain');
C = input('Mean wind speed');

R = 20;
rho = 1.2;
J = 644877;
windV = 8;
tsrOptim = 5.29;
CpMax = 0.4528

index = 1;

  for i=1:120  
    LUT(i) = 0.1;
  endfor
  
buildPowerCoefficientsLUT(LUT);

%lookupPowerCoefficient(8,3,LUT);

xinit = [0,4];

options = odeset('RelTol',1e-6,'AbsTol',1e-6,'InitialStep',tend/1e3,'MaxStep',tend/1e3);

[t,x] = ode45(@rhs_windturbine_2,[tstart,tend],xinit,options);

%plot(t,x(:,2),'r');

for i = 1 : length(t)
  ttsr(i) = R*x(i,2)/applyWind(t(i));
  CCp(i) = lookupPowerCoefficient(ttsr(i),3.7,LUT);
endfor


subplot(3,1,1);
plot(t,x(:,2),'r');
title('omega');
subplot(3,1,2);
plot(t,ttsr,'r');
title('tsr');
subplot(3,1,3);
plot(t,CCp,'r');
title('Cp');